Code for browsing all fields from the names database, where l_name is
exactly equal to the variable searcher, and using the F2 key to edit and
the F3 key to delete:

    to = tbrowsenew(1, 1, 6, 78)
    // Index on l_name + f_name
    USE names INDEX names 

    // Add each field from the current database as a 
    // tbcolumn object to the "to" tbrowse object
    aeval(dbstruct(), ;
          {|f| ;
           to:addColumn( ;
              tbColumnNew( f[DBS_NAME], ;
                           fieldBlock(f[DBS_NAME]) ) ;
                          ) ;
          })

    // We don't want to see Spencer or Spence-Brown. If you want an
    // inexact filter, trim searcher instead of padding with spaces
    searcher = "Spence    "

    to:goTopBlock = {|| gototop(searcher)}
    to:goBottomBlock = {|| gotobottom(searcher)}
    to:skipBlock = {|n| skipper(n, searcher) }

    to:cargo := .F.
    bBefore := {|nKey| iif(nKey = K_ENTER .OR. ;
                           nKey = K_ESC, ;
                           to:cargo := .T., .F.)}
    bWhile := {|| !to:cargo .AND. l_name = searcher }
    bAfter := {|nKey, to| ;
                exceptions(nKey, to, searcher)}
    SEEK searcher
    tbrowse(to, bBefore, bWhile, bAfter)

