Exception handling code implementing delete and edit:


    // Must return .T. if it handled the key, .F. otherwise
    FUNCTION exceptions(nKey, to, searcher)

    FIELD l_name, f_name IN names
    LOCAL lKeyHandled := .T., cOldKey, cNewKey, ;
          goThisField, rSaveRecno

        DO CASE
            CASE nKey = K_F2    // Edit Key
                // First save old key value
                cOldKey := l_name + f_name

                // Each column's block instance variable
                // is a get/set block. Create a Get
                // Object for it
                goThisField := getnew(row(), col(), ;
                                  to:getColumn(to:ColPos):block, "")

                // Locking considerations in multi-
                // user environments
                readmodal({goThisField})

                // If record is not now in scope, restart from the
                // first one in the scope
                IF l_name != searcher
                    SEEK searcher
                    to:refreshAll()
                ELSE
                    // Still in scope, but the key may have changed ...
                    IF l_name + f_name != cOldKey
                        // This convoluted code is required to
                        // ensure the same record is highlighted
                        rSaveRecno := recno()
                        to:refreshAll()

                        DO WHILE !to:stabilize()
                        ENDDO

                        DO WHILE recno() != rSaveRecno
                            to:up()
                            DO WHILE !to:stabilize()
                            ENDDO
                        ENDDO
                    ELSE
                        // Key didn't change, just redraw current row 
                        to:refreshCurrent()
                    ENDIF
                ENDIF

            CASE nKey = K_F3    // Delete Key
                // Redraw starting on first record in scope
                // Locking considerations in multi-user environments
                DELETE
                SEEK searcher
                to:refreshAll()

            OTHERWISE
                lKeyHandled := .F.
        ENDCASE

    RETURN lKeyHandled

