Code for browsing l_name, f_name, and tel fields from the names database
for a specified occurrence, in this case l_name = "Spence":

    FIELD l_name, f_name, tel IN names
    USE names INDEX l_name    // Indexed on l_name

    to = tbrowseDb(1, 1, 23, 78)
    to:addColumn(tbColumnNew("l_names", {|| l_name }))
    to:addColumn(tbColumnNew("f_names", {|| f_name }))
    to:addColumn(tbColumnNew("Tels",    {|| tel    }))

    to:goTopBlock    = {|| goToTop()}
    to:goBottomBlock = {|| goToBottom()}
    to:skipBlock     = {|n| skipper(n) }

    SEEK "Spence"
    IF !eof()
        tbrowse(to)
    ENDIF


    // Go to the FIRST record in the database where the first
    // six characters of l_name = "Spence"
    FUNCTION goToTop

        SEEK "Spence"

    RETURN NIL


    // Go to the LAST record in the database where the first
    // six characters of l_name = "Spence"
    FUNCTION goToBottom

    LOCAL lSaveSoft := set(_SET_SOFTSEEK, .T.)

        SEEK "Spencf"
        SKIP -1
        set(_SET_SOFTSEEK, lSaveSoft)

    RETURN NIL


    // Skip in the database as long as l_name = "Spence"
    FUNCTION skipper(nNumToSkip)

    FIELD l_name IN names
    LOCAL nNumSkipped := 0, ;
          nDirection := iif(nNumToSkip > 0, 1, -1)

        DO WHILE !eof() .AND. !bof() .AND. ;
                 nNumSkipped != nNumToSkip .AND. ;
                 l_name = "Spence"

            SKIP nDirection
            nNumSkipped += nDirection

        ENDDO

        IF eof()
            SKIP -1
            nNumSkipped--
        ELSEIF bof()
            nNumSkipped++
        ELSEIF l_name != "Spence"
            SKIP -nDirection
            nNumSkipped += -nDirection
        ENDIF

    RETURN nNumSkipped

