Code for implementing filtering using the gototop, gotobottom, and
skipper functions:

    // Go to the first record equal to searcher
    FUNCTION gototop(searcher)

        SEEK searcher

    RETURN NIL

    // Go to the last record equal to searcher
    FUNCTION gotobottom(searcher)

    LOCAL lSaveSoft := set(_SET_SOFTSEEK, .T.)

        SEEK substr(searcher, 1, len(searcher) - 1) + ;
             chr(asc(substr(searcher, -1)) + 1)
        SKIP -1
        set(_SET_SOFTSEEK, lSaveSoft)

    RETURN NIL

    // Skip up to nNumToSkip records WHILE l_name = searcher
    FUNCTION skipper(nNumToSkip, searcher)

    FIELD l_name IN names
    LOCAL nNumSkipped := 0, ;
          nDirection := iif(nNumToSkip > 0, 1, -1)

        DO WHILE !eof() .AND. !bof() .AND. ;
                  nNumSkipped != nNumToSkip .AND. ;
                  l_name = searcher

            SKIP nDirection
            nNumSkipped += nDirection

        ENDDO

        IF eof()
            SKIP -1
            nNumSkipped--
        ELSEIF bof()
            nNumSkipped++
        ELSEIF l_name != searcher
            SKIP -nDirection
            nNumSkipped += -nDirection
        ENDIF

    RETURN nNumSkipped

